/*
 Teknisa - Tecnologia em Informtica

 Nome: Exporta as transferncias realizadas  pela filial consolidadas por ms.

 Criao:
 04/05/2012 - Welbert Moitinha
*/

CREATE OR REPLACE PROCEDURE EXPORTA_TRANSF_ESTOQUE_TM(P_CDFILIAL   IN  VARCHAR2,
                                                      P_CDOPERADOR IN  VARCHAR2,
                                                      P_DTINICIAL  IN  DATE,
                                                      P_DTFINAL    IN  DATE)
IS
   V_COUNT FLOAT;
   V_CDFILIAL VARCHAR2(4);
   V_NRLANESTENTR VARCHAR2(10);
   V_CDFILIALENTR VARCHAR2(4);
   V_CDEMPRESA VARCHAR2(2);
   V_CDALMOXSAID VARCHAR2(6);
   V_CDALMOXENTR VARCHAR2(6);
   V_DTMOVIESTQ DATE;

   V_VRTOTLANCTOMES FLOAT;
   V_QTDETOTALMES FLOAT;
   V_CDPRODUTO VARCHAR2(10);
   V_CDPRODMOVI VARCHAR2(10);

   CURSOR C_REG IS
      SELECT C.CDFILIAL, C.NRLANESTENTR, C.CDFILIALENTR, F.CDEMPRESA,
             C.CDALMOXENTR CDALMOXSAID, C.CDALMOXSAID CDALMOXENTR, DTMOVIESTQ
        FROM CTRLMOVIESTQ C, FILIAL F
       WHERE C.CDFILIAL = P_CDFILIAL AND
             C.DTMOVIESTQ BETWEEN P_DTINICIAL AND P_DTFINAL AND
             F.CDFILIAL = C.CDFILIAL;

   CURSOR C_ITEM(C_NRLANESTENTR IN VARCHAR2, C_CDFILIALENTR IN VARCHAR2, C_CDFILIAL IN VARCHAR2) IS
      SELECT SUM(I.QTLANCTOEST * I.VRUNILANCTO) VRTOTLANCTOMES,
             SUM(I.QTLANCTOEST) QTDETOTALMES, I.CDPRODUTO, I.CDPRODMOVI
        FROM ITLANCTOEST I
       WHERE (I.NRLANCESTQ  = C_NRLANESTENTR) AND
             (I.CDFILIMOVI  = C_CDFILIALENTR)  AND
             (I.CDFILIAL = C_CDFILIAL)
       GROUP BY I.CDPRODUTO, I.CDPRODMOVI;

BEGIN
   /*FOR C_REG IN ( SELECT C.CDFILIAL, C.NRLANESTENTR, C.CDFILIALENTR, F.CDEMPRESA,
                         C.CDALMOXENTR CDALMOXSAID, C.CDALMOXSAID CDALMOXENTR, DTMOVIESTQ
                    FROM
                       CTRLMOVIESTQ C, FILIAL F
                   WHERE
                      C.CDFILIAL = P_CDFILIAL AND
                      C.DTMOVIESTQ BETWEEN P_DTINICIAL AND P_DTFINAL AND
                      F.CDFILIAL = C.CDFILIAL
                   ORDER BY C.DTMOVIESTQ, C.NRLANESTENTR )LOOP

   */

   OPEN C_REG;
   LOOP
      FETCH C_REG INTO V_CDFILIAL, V_NRLANESTENTR, V_CDFILIALENTR, V_CDEMPRESA,
                       V_CDALMOXSAID, V_CDALMOXENTR, V_DTMOVIESTQ;
      EXIT WHEN C_REG%NOTFOUND;

      OPEN C_ITEM(V_NRLANESTENTR, V_CDFILIALENTR, V_CDFILIAL);
      LOOP
         FETCH C_ITEM INTO V_VRTOTLANCTOMES, V_QTDETOTALMES, V_CDPRODUTO, V_CDPRODMOVI;
         EXIT WHEN C_ITEM%NOTFOUND;
      /*FOR C_ITEM IN( SELECT SUM(I.QTLANCTOEST * I.VRUNILANCTO) VRTOTLANCTOMES,
                          SUM(I.QTLANCTOEST) QTDETOTALMES, I.CDPRODUTO, I.CDPRODMOVI
                     FROM ITLANCTOEST I
                    WHERE
                       (I.NRLANCESTQ  = C_REG.NRLANESTENTR) AND
                       (I.CDFILIMOVI  = C_REG.CDFILIALENTR)  AND
                       (I.CDFILIAL = C_REG.CDFILIAL )
                    GROUP BY
                       I.CDPRODUTO, I.CDPRODMOVI)LOOP*/

         SELECT COUNT(*)
           INTO V_COUNT
           FROM EXPORTACAOTM
          WHERE
             CDFILIALTM = V_CDFILIAL AND
             CDEMPRESATM = V_CDEMPRESA AND
             DTEXPORTTM = V_DTMOVIESTQ AND
             CDALMOXORIGTM = V_CDALMOXENTR AND
             CDALMOXDESTTM = V_CDALMOXSAID AND
             CDPRODUTOTM = V_CDPRODUTO AND
             CDPRODMOVITM = V_CDPRODMOVI AND
             NRLANESTENTR = V_NRLANESTENTR
             ;

         IF V_COUNT = 0 THEN
            INSERT INTO EXPORTACAOTM( CDEMPRESATM, CDFILIALTM, DTEXPORTTM, CDALMOXORIGTM, CDALMOXDESTTM, CDPRODUTOTM,
                                      CDPRODMOVITM, QTLANCTOESTTM, VRTOTLANCTOTM, CDOPERADORTM, NRLANESTENTR)
                  VALUES(V_CDEMPRESA, V_CDFILIAL, V_DTMOVIESTQ, V_CDALMOXENTR, V_CDALMOXSAID, V_CDPRODUTO,
                         V_CDPRODMOVI, V_QTDETOTALMES, V_VRTOTLANCTOMES, P_CDOPERADOR, V_NRLANESTENTR);
         ELSE
            UPDATE EXPORTACAOTM
               SET QTLANCTOESTTM = V_QTDETOTALMES,
                   VRTOTLANCTOTM = V_VRTOTLANCTOMES
             WHERE CDFILIALTM = V_CDFILIAL AND
                   CDEMPRESATM = V_CDEMPRESA AND
                   DTEXPORTTM = V_DTMOVIESTQ AND
                   CDALMOXORIGTM = V_CDALMOXENTR AND
                   CDALMOXDESTTM = V_CDALMOXSAID AND
                   CDPRODUTOTM = V_CDPRODUTO AND
                   CDPRODMOVITM = V_CDPRODMOVI AND
                   NRLANESTENTR  = V_NRLANESTENTR;
         END IF;
      END LOOP;
      COMMIT;
      CLOSE C_ITEM;
   END LOOP;

   CLOSE C_REG;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_TRANSF_ESTOQUE_TM','6.19.xxx'); END;
/



